#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "common.h"

int main(void)
{
	ssize_t bread = 1, tok;
	size_t pos = 0;
	char buffer[513];
	IRC_Message out;
	for (; bread > 0;) {
		if ((tok = get_buffer_line(buffer, &out)) > 0) {
			if (out.cmd == RPL_LIST) {
				printf(ANSI_COLOR_YELLOW "%s" ANSI_COLOR_RESET "\nTopic: %s\nUsers: %s\n", out.args[1], out.args[3], out.args[2]);
				print_local_time(out.tags.time.value);
				putchar('\n');
			} else if (out.cmd == RPL_LISTEND) {
				printf(ANSI_COLOR_RED "----- END" ANSI_COLOR_RESET "\n");
			} else if (out.cmd == RPL_LISTSTART) {
				// NOTE: DEPRECATED BUT STILL USED
				printf(ANSI_COLOR_GREEN "----- START" ANSI_COLOR_RESET "\n");
			}
			for (long unsigned int x = 0; x < sizeof(buffer) && *(buffer + tok + x); x++) *(buffer + x) = *(buffer + x + tok);
			pos -= (unsigned long)tok;
			*(buffer + pos) = '\0';
			memset(&out, '\0', sizeof(out));
			continue;
		}
		if ((bread = read(0, buffer + pos, sizeof(buffer) - 1 - pos)) > 0) {
			pos += (size_t)bread;
			buffer[pos] = '\0';
		}
	}
	return 0;
}
